package ru.dbotthepony.mc.otm.client

import com.mojang.blaze3d.platform.InputConstants
import net.minecraft.client.gui.screens.inventory.InventoryScreen
import net.minecraftforge.client.event.MovementInputUpdateEvent
import net.minecraftforge.client.event.ScreenEvent
import ru.dbotthepony.mc.otm.capability.matteryPlayer
import ru.dbotthepony.mc.otm.client.render.Widgets18
import ru.dbotthepony.mc.otm.client.screen.ExoSuitInventoryScreen
import ru.dbotthepony.mc.otm.client.screen.panels.LargeSquareButtonPanel
import ru.dbotthepony.mc.otm.client.screen.panels.Panel2Widget
import ru.dbotthepony.mc.otm.core.TranslatableComponent
import ru.dbotthepony.mc.otm.registry.AndroidFeatures

object ClientEventHandler {
	fun inputEvent(event: MovementInputUpdateEvent) {
		val ply = event.entity
		val input = event.input

		val cap = ply.matteryPlayer ?: return

		if (!cap.isAndroid || cap.hasFeature(AndroidFeatures.AIR_BAGS))
			return

		if (ply.abilities.mayfly) {
			cap.lastJumpTicks = 14
		} else {
			if (ply.isInWater) {
				if (ply.isOnGround) {
					cap.lastJumpTicks = 14
				}

				if (ply.isSwimming) {
					ply.isSwimming = false
				}

				if (cap.lastJumpTicks <= 0) {
					input.jumping = false
					input.up = false
				} else {
					cap.lastJumpTicks--
				}
			}
		}
	}

	var ignoreInventoryOpen = false

	fun postScreenInit(event: ScreenEvent.Init.Post) {
		val player = minecraft.player?.matteryPlayer ?: return

		val screen = event.screen as? InventoryScreen ?: return

		if (player.hasExoSuit) {
			event.addListener(Panel2Widget(LargeSquareButtonPanel(event.screen as InventoryScreen, null,
				x = screen.guiLeft + screen.xSize + 2f,
				y = screen.guiTop.toFloat(),
				skinElement = Widgets18.RETURN_ARROW_LEFT, onPress = {
				val mouseX = minecraft.mouseHandler.xpos()
				val mouseY = minecraft.mouseHandler.ypos()

				event.screen.onClose()
				minecraft.setScreen(ExoSuitInventoryScreen(player.exoSuitMenu))

				InputConstants.grabOrReleaseMouse(minecraft.window.window, 212993, mouseX, mouseY)
			}).also { it.tooltip = TranslatableComponent("otm.gui.exosuit.go_in") }))
		}
	}

	fun screenOpen(event: ScreenEvent.Opening) {
		if (ignoreInventoryOpen || minecraft.player?.isCreative == true) {
			return
		}

		val player = minecraft.player?.matteryPlayer ?: return

		if (player.hasExoSuit && event.newScreen is InventoryScreen) {
			event.newScreen = ExoSuitInventoryScreen(player.exoSuitMenu)
		}
	}
}
